Subject: Re: linux-next: PowerPC boot failures in next-20120521

From: Stephen Rothwell <[email-masked]>
Date: Tue, 22 May 2012 13:03:54 +1000

Hi David,

On Mon, 21 May 2012 18:53:37 -0700 (PDT) David Rientjes <[email-masked]> wrote:
>
> Yeah, it's sched/numa since that's what introduced numa_init().  It does 
> for_each_node() for each node and does a kmalloc_node() even though that 
> node may not be online.  Slub ends up passing this node to the page 
> allocator through alloc_pages_exact_node().  CONFIG_DEBUG_VM would have 
> caught this and your config confirms its not enabled.
> 
> sched/numa either needs a memory hotplug notifier or it needs to pass 
> NUMA_NO_NODE for nodes that aren't online.  Until we get the former, the 
> following should fix it.
> 
> 
> sched, numa: Allocate node_queue on any node for offline nodes
> 
> struct node_queue must be allocated with NUMA_NO_NODE for nodes that are 
> not (yet) online, otherwise the page allocator has a bad zonelist.
> 
> Signed-off-by: David Rientjes <[email-masked]>

Thanks, that fixes it.

Tested-by: Stephen Rothwell <[email-masked]>

-- 
Cheers,
Stephen Rothwell                    [email-masked]